
var macros = {};

// todo:
// var ignore_comments = true;
// var acceptable_extensions = [];
// var remap_on_change = true;
// var query_symbols = {
//     beginning: "@",
//     end: "@"
// }

function Sequencer(finished) {
    // return this;
}
Sequencer.prototype = {
    config: function(config, finish) {
        var instance = this;

        var ops = 2;
        function tryFinish() {
            ops--;
            if (ops === 0) {
                finish();
            }
        }

        if (!config.hasOwnProperty('import paths')) {
            throw new Error('no base "module repo" configured');
        }

        if (Array.isArray(config["import paths"])) {
            instance["import paths"] = config["import paths"];
        }
        else if (typeof config["import paths"] === 'string') {
            instance["import paths"] = [];
            instance["import paths"].push(config["import paths"]);
        }

        if (config.hasOwnProperty('data')) {
            require('./lib/data/core').set(config.data, function() {
                tryFinish();
            })
        }

        require("./lib/mapper/activate").create({
            "import paths": instance["import paths"]
        }, function(map){
            tryFinish();
        });
    },
    "get package 1": function(input, output) {
        var sub_module = this;

        // allow passage of data into sequencer
        var launch_params_array = input["launch params"] || [];
        for (var launch_iterator=0; launch_iterator < launch_params_array.length; launch_iterator++) {
            if (typeof launch_params_array[launch_iterator] === 'object') {
                launch_params_array[launch_iterator] = JSON.stringify(launch_params_array[launch_iterator], null, 4);
            }
            else if (typeof launch_params_array[launch_iterator] === 'string') {
                launch_params_array[launch_iterator] = '\"' + launch_params_array[launch_iterator] + '\"';
            }
        }
        var launch_params = require("./lib/concatenate")(launch_params_array).with(", ");


        sub_module.manifest = function() {
            if (input.hasOwnProperty("manifest")) {
                var manifest = new (require("./structures/Manifest"))();
                manifest.entries = input.manifest;

                return manifest;
            }
            else {
                return new (require("./structures/Manifest"))();
            }
        }();
        sub_module.sequence = new (require("./structures/Sequence"))();

        var query = input["query"].split(" ");

        require("./import/query parser")(query, sub_module["import paths"], function(possible_paths) {
            require("./import/core")({
                "sub_module": sub_module,
                "possible_paths": possible_paths
            }, function(launch_code, sequence, manifest){
                // external transform

                // var add to input queue
                var script = require("./lib/concatenate")([
                    '<script charset="UTF-8">',
                    "window.bundle = {};\n",
                    "window.manifest = [];\n",
                    sequence["to string"](0) + "\n",
                    manifest["to string"](0) + "\n",
                    'window.bundle[' + launch_code + '](' + launch_params + ');',
                    "</script>"
                ]).with("");

                output(script);
            });
        });
    },
    "get package 2+": function(input, output) {
        var sub_module = this;

        sub_module.manifest = function() {
            if (input.hasOwnProperty("manifest")) {
                var manifest = new (require("./structures/Manifest"))();
                manifest.entries = input.manifest;

                return manifest;
            }
            else {
                return new (require("./structures/Manifest"))();
            }
        }();
        sub_module.sequence = new (require("./structures/Sequence"))();

        const startIndex = sub_module.manifest.entries.length;

        var query = input["query"].toLowerCase().split(" ");

        require("./import/query parser")(query, sub_module["import paths"], function(possible_paths) {
            require("./import/core")({
                "sub_module": sub_module,
                "possible_paths": possible_paths
            }, function(launch_code, sequence, manifest){
                // external transform

                var sequenceString = sequence["to string"](startIndex);
                var manifestString = manifest["to string"](startIndex);

                var optionalNewline = "";
                if (sequenceString.length > 0) {
                    optionalNewline = "\n";
                }

                // var add to input queue
                var script = require("./lib/concatenate")([
                    "*" + launch_code + "*",
                    sequence["to string"](startIndex),
                    optionalNewline,
                    manifest["to string"](startIndex),
                    optionalNewline
                ]).with("");

                output(script);
            });
        });
    },
    "print config": function(output) {
        var instance = this;
        output(instance)
    }
};

module.exports = new Sequencer();
