


function Interpretation(query, sub_module, output) {
    var manifest = sub_module.manifest;
    var sequence = sub_module.sequence;

    if (query[0] === "import") {
        require("./../import/query parser")(query, sub_module["import paths"], function(possible_paths) {
            require("./../lib/map.get file id")({
                sub_module: sub_module,
                possible_paths: possible_paths
            }, function(map, id){
                var dna_path = map[id];

                require("./../lib/manifest.index of")(manifest, id, function(index) {
                    if (index === null) {(function(){
                        // allocate position in memory
                        const spot_in_memory = manifest.entries.length;
                        manifest.add(spot_in_memory, id);

                        require("./../lib/read file at path")(sub_module, dna_path, id, function(content, bundle_params) {
                            sequence.add(spot_in_memory, bundle_params, content);

                            var internal_transform = "window.bundle[" + spot_in_memory + "]()";
                            output(internal_transform);
                        });
                    })()}
                    else {(function(){
                        var internal_transform = "window.bundle[" + index + "]()";
                        output(internal_transform);
                    })()}
                });
            });
        });
    }
    else if (query[0] === "retrieve") {
        require("log")("retrieve query found", query);

        var key = "";
        (function() {
            key = query[1];
            if (query.length > 2) {
                for (var x=2; x<=query.length-1; x++) {
                    key += " " + query[x];
                }
            }
        })();

        require("./data/core").get(key, function(data) {
            output(JSON.stringify(data));
        });
    }
    else if (query[0] === "params" || query[0] === "param") {
        var params = [];

        for (var i=1; i<query.length; i++) {
            params.push(query[i]);
        }

        output(params, "params");
    }
    else {
        // unrecognized query
        output(null);
    }
}


module.exports = Interpretation;
