

function guid() {
    function s4() {
        return Math.floor((1 + Math.random()) * 0x10000)
            .toString(16)
            .substring(1);
    }
    return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
        s4() + '-' + s4() + s4() + s4();
}

function getNewUuid(obj) {
    var uuid = guid();

    if (obj.hasOwnProperty(uuid)) {
        return getNewUuid(obj);
    }
    else {
        return uuid;
    }
}



function cloneObject(obj) {
    if (obj === null || typeof obj !== 'object') {
        return obj;
    }

    var temp = obj.constructor(); // give temp the original obj's constructor
    for (var key in obj) {
        temp[key] = cloneObject(obj[key]);
    }

    return temp;
}

function MergeRecursive(obj1, obj2) {
  for (var p in obj2) {
    try {
      // Property in destination object set; update its value.
      if ( obj2[p].constructor==Object ) {
        obj1[p] = MergeRecursive(obj1[p], obj2[p]);

      } else {
        obj1[p] = obj2[p];

      }

    } catch(e) {
      // Property in destination object not set; create it and set its value.
      obj1[p] = obj2[p];

    }
  }

  return obj1;
}

function readArray() {}
readArray.prototype.start = function(i) {
    var l = this;

    l.array = i.array;
    l.each = i.each;
    l.done = i.done;
    l.counter = 0;

    l.each(l.array[l.counter], l.counter);
};
readArray.prototype.next = function() {
    var l = this;
    if (l.counter === l.array.length - 1) {
        l.done();
        return false;
    }

    l.counter++;
    l.each(l.array[l.counter], l.counter);
};

var defaults = {
    exclude: ['*.jsx']
}

function generate(ಠ, output) {
    var import_paths = ಠ["import paths"];

    if (!import_paths) {
        throw new Error("import paths need to be passed into map generator");
    }

    var map = {
        name: "dna map"
    };
    map.created = new Date();
    map.map = {};

    var arrayReader = new readArray();
    arrayReader.start({
        array: import_paths,
        each: function(entry, index) {
            require('recursive-readdir')(entry, ['*.jsx'], function (err, files) {
                if (err) throw new Error(err);

                for (var i=0; i<files.length; i++) {
                    var uuid = getNewUuid(map.map);
                    map.map[uuid] = files[i];
                }

                arrayReader.next();
            });
        },
        done: function() {
            output(map);
        }
    });


}
module.exports = generate;
