
// reads the file specified by the path variable

module.exports = function(sub_module, path, id, output) {
    var done_conditions = {
        "end of readable stream": false,
        "waiting on queries": 0
    };


    // data structures
    var bundle_params = [];


    var ll = new (require("./../structures/Linked List"))();
    var queries = [];

    var readable = require("fs").createReadStream(path, {
        flags: 'r',
        encoding: 'utf8',
        fd: null,
        mode: 0o666,
        autoClose: true
    });
    readable.on('error', function(error) {
        throw new Error('There was an error reading: \n' + instance.path);
    });
    readable.on('readable', function() {
        var char;

        var readingQuery = false; // number of the query
        var queryIndex = null;
        while (null !== (char = readable.read(1))) {

            // start of a new query
            if (readingQuery) {
                if (char !== "@") {
                    queries[queryIndex].value += char;
                    continue;
                }
                else { (function() {
                    const index = queryIndex;
                    var query =  queries[index].value.split(" ");

                    // interpret the query
                    setTimeout(function() {
                        new (require("./interpretor"))(query, sub_module, function (internal_transform, type) {
                            if (type === "params") {
                                bundle_params.push(internal_transform);
                            }
                            else if (internal_transform === null) {
                                
                            }
                            else {
                                ll["insert"](
                                    internal_transform
                                )["after"](
                                    queries[index]["previous node"]
                                );
                            }

                            done_conditions["waiting on queries"]--;
                            tryDone();
                        })
                    }, 0);

                    readingQuery = false;
                })()}
            }

            // start of a new query
            else if (char === "@") {
                queries.push({
                    "previous node": ll.last,
                    "value": "" /* initializes this property as a string */
                });

                readingQuery = true;
                queryIndex = queries.length - 1;
                done_conditions["waiting on queries"]++;
            }

            // regular JavaScript
            else {
                ll["append"](char);
            }
        }
    });

    readable.on('end', function() {
        done_conditions["end of readable stream"] = true;
        tryDone();
    });

    function tryDone() {
        // write(JSON.stringify(done_conditions, null, 2));

        if (done_conditions["end of readable stream"] && done_conditions["waiting on queries"] === 0) {
            ll["to string"](function(content) {
                output(content, bundle_params);
            });
        }
    };
};
